diff --git a/.mailmap b/.mailmap
index 3f5bab26a8..9d9e015607 100644
--- a/.mailmap
+++ b/.mailmap
@@ -1299,6 +1299,7 @@ Shuanglin Wang <shuanglin.wang@broadcom.com>
 Shuki Katzenelson <shuki@lightbitslabs.com>
 Shun Hao <shunh@nvidia.com>
 Shu Shen <shu.shen@radisys.com>
+Shujing Dong <shujing.dong@corigine.com>
 Shweta Choudaha <shweta.choudaha@att.com>
 Shyam Kumar Shrivastav <shrivastav.shyam@gmail.com>
 Shy Shyman <shys@nvidia.com> <shys@mellanox.com>
diff --git a/drivers/common/nfp/meson.build b/drivers/common/nfp/meson.build
new file mode 100644
index 0000000000..45871dfe35
--- /dev/null
+++ b/drivers/common/nfp/meson.build
@@ -0,0 +1,14 @@
+# SPDX-License-Identifier: BSD-3-Clause
+# Copyright (c) 2023 Corigine, Inc.
+
+if not is_linux or not dpdk_conf.get('RTE_ARCH_64')
+    build = false
+    reason = 'only supported on 64-bit Linux'
+endif
+
+deps += ['bus_pci']
+
+sources = files(
+        'nfp_common_log.c',
+        'nfp_common_pci.c',
+)
diff --git a/drivers/common/nfp/nfp_common_log.c b/drivers/common/nfp/nfp_common_log.c
new file mode 100644
index 0000000000..e69e608eb9
--- /dev/null
+++ b/drivers/common/nfp/nfp_common_log.c
@@ -0,0 +1,8 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2023 Corigine, Inc.
+ * All rights reserved.
+ */
+
+#include "nfp_common_log.h"
+
+RTE_LOG_REGISTER_SUFFIX(nfp_logtype_common, common, NOTICE);
diff --git a/drivers/common/nfp/nfp_common_log.h b/drivers/common/nfp/nfp_common_log.h
new file mode 100644
index 0000000000..066e38e688
--- /dev/null
+++ b/drivers/common/nfp/nfp_common_log.h
@@ -0,0 +1,16 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2023 Corigine, Inc.
+ * All rights reserved.
+ */
+
+#ifndef __NFP_COMMON_LOG_H__
+#define __NFP_COMMON_LOG_H__
+
+#include <rte_log.h>
+
+extern int nfp_logtype_common;
+#define PMD_DRV_LOG(level, fmt, args...) \
+	rte_log(RTE_LOG_ ## level, nfp_logtype_common, \
+			"%s(): " fmt "\n", __func__, ## args)
+
+#endif/* __NFP_COMMON_LOG_H__ */
diff --git a/drivers/common/nfp/nfp_common_pci.c b/drivers/common/nfp/nfp_common_pci.c
new file mode 100644
index 0000000000..1aa8dd4bbd
--- /dev/null
+++ b/drivers/common/nfp/nfp_common_pci.c
@@ -0,0 +1,274 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2023 Corigine, Inc.
+ * All rights reserved.
+ */
+
+#include "nfp_common_pci.h"
+
+#include <string.h>
+
+#include <rte_class.h>
+#include <rte_devargs.h>
+#include <rte_kvargs.h>
+
+#include "nfp_common_log.h"
+
+/* Reported driver name. */
+#define NFP_PCI_DRIVER_NAME "nfp_common_pci"
+
+static struct rte_pci_driver nfp_common_pci_driver;
+
+/* PCI ID table is build dynamically based on registered nfp drivers. */
+static struct rte_pci_id *nfp_pci_id_table;
+
+/* Head of list of drivers. */
+static TAILQ_HEAD(nfp_drivers, nfp_class_driver) nfp_drivers_list =
+		TAILQ_HEAD_INITIALIZER(nfp_drivers_list);
+
+static bool nfp_common_initialized;
+
+static const struct {
+	const char *name;
+	enum nfp_class drv_class;
+} nfp_classes[] = {
+	{ .name = "eth",      .drv_class = NFP_CLASS_ETH },
+};
+
+static enum nfp_class
+nfp_class_name_to_value(const char *class_name)
+{
+	uint32_t i;
+
+	for (i = 0; i < RTE_DIM(nfp_classes); i++) {
+		if (strcmp(class_name, nfp_classes[i].name) == 0)
+			return nfp_classes[i].drv_class;
+	}
+
+	return NFP_CLASS_INVALID;
+}
+
+static uint32_t
+nfp_pci_id_table_size_get(const struct rte_pci_id *id_table)
+{
+	uint32_t table_size;
+
+	if (id_table == NULL)
+		return 0;
+
+	for (table_size = 0; id_table->vendor_id != 0; id_table++)
+		table_size++;
+
+	return table_size;
+}
+
+static bool
+nfp_pci_id_exists(const struct rte_pci_id *id,
+		const struct rte_pci_id *table,
+		uint32_t next_idx)
+{
+	uint32_t i;
+
+	if (next_idx == 0)
+		return false;
+
+	for (i = 0; i < next_idx; i++) {
+		if (id->device_id == table[i].device_id &&
+				id->vendor_id == table[i].vendor_id &&
+				id->subsystem_vendor_id == table[i].subsystem_vendor_id &&
+				id->subsystem_device_id == table[i].subsystem_device_id)
+			return true;
+	}
+
+	return false;
+}
+
+static void
+nfp_pci_id_insert(struct rte_pci_id *new_table,
+		uint32_t *next_idx,
+		const struct rte_pci_id *id_table)
+{
+	if (id_table == NULL)
+		return;
+
+	/* Add non duplicate entries to new table. */
+	for (; id_table->vendor_id != 0; id_table++) {
+		if (!nfp_pci_id_exists(id_table, new_table, *next_idx)) {
+			new_table[*next_idx] = *id_table;
+			(*next_idx)++;
+		}
+	}
+}
+
+static int
+nfp_pci_id_table_update(const struct rte_pci_id *driver_id_table)
+{
+	uint32_t i = 0;
+	uint32_t num_ids = 0;
+	struct rte_pci_id *old_table;
+	const struct rte_pci_id *id_iter;
+	struct rte_pci_id *updated_table;
+
+	old_table = nfp_pci_id_table;
+	if (old_table != NULL)
+		num_ids = nfp_pci_id_table_size_get(old_table);
+	num_ids += nfp_pci_id_table_size_get(driver_id_table);
+
+	/* Increase size by one for the termination entry of vendor_id = 0. */
+	num_ids += 1;
+	updated_table = calloc(num_ids, sizeof(struct rte_pci_id));
+	if (updated_table == NULL)
+		return -ENOMEM;
+
+	if (old_table == NULL) {
+		/* Copy the first driver's ID table. */
+		for (id_iter = driver_id_table; id_iter[i].vendor_id != 0; i++)
+			updated_table[i] = id_iter[i];
+	} else {
+		/* First copy existing table entries. */
+		for (id_iter = old_table; id_iter[i].vendor_id != 0; i++)
+			updated_table[i] = id_iter[i];
+		/* New id to be added at the end of current ID table. */
+		nfp_pci_id_insert(updated_table, &i, driver_id_table);
+
+		free(old_table);
+	}
+
+	/* Terminate table with empty entry. */
+	updated_table[i].vendor_id = 0;
+	nfp_pci_id_table = updated_table;
+	nfp_common_pci_driver.id_table = nfp_pci_id_table;
+
+	return 0;
+}
+
+static int
+nfp_kvarg_dev_class_handler(__rte_unused const char *key,
+		const char *class_str,
+		void *opaque)
+{
+	enum nfp_class *dev_class = opaque;
+
+	if (class_str == NULL)
+		return *dev_class;
+
+	*dev_class = nfp_class_name_to_value(class_str);
+
+	return 0;
+}
+
+static enum nfp_class
+nfp_parse_class_options(const struct rte_devargs *devargs)
+{
+	struct rte_kvargs *kvargs;
+	enum nfp_class dev_class = NFP_CLASS_ETH;
+
+	if (devargs == NULL)
+		return dev_class;
+
+	kvargs = rte_kvargs_parse(devargs->args, NULL);
+	if (kvargs == NULL)
+		return dev_class;
+
+	if (rte_kvargs_count(kvargs, RTE_DEVARGS_KEY_CLASS) != 0) {
+		rte_kvargs_process(kvargs, RTE_DEVARGS_KEY_CLASS,
+				nfp_kvarg_dev_class_handler, &dev_class);
+	}
+
+	rte_kvargs_free(kvargs);
+
+	return dev_class;
+}
+
+static int
+nfp_drivers_probe(struct rte_pci_device *pci_dev,
+		enum nfp_class class)
+{
+	int32_t ret = 0;
+	struct nfp_class_driver *driver;
+
+	TAILQ_FOREACH(driver, &nfp_drivers_list, next) {
+		if ((driver->drv_class & class) == 0)
+			continue;
+
+		ret = driver->probe(pci_dev);
+		if (ret < 0) {
+			PMD_DRV_LOG(ERR, "Failed to load driver %s", driver->name);
+			return ret;
+		}
+	}
+
+	return 0;
+}
+
+static int
+nfp_common_pci_probe(struct rte_pci_driver *pci_drv __rte_unused,
+		struct rte_pci_device *pci_dev)
+{
+	enum nfp_class class;
+	struct rte_device *eal_dev = &pci_dev->device;
+
+	PMD_DRV_LOG(INFO, "probe device %s.", eal_dev->name);
+
+	class = nfp_parse_class_options(eal_dev->devargs);
+	if (class == NFP_CLASS_INVALID) {
+		PMD_DRV_LOG(ERR, "Unsupported nfp class type: %s",
+				eal_dev->devargs->args);
+		return -ENOTSUP;
+	}
+
+	return nfp_drivers_probe(pci_dev, class);
+}
+
+static int
+nfp_common_pci_remove(__rte_unused struct rte_pci_device *pci_dev)
+{
+	return 0;
+}
+
+static struct rte_pci_driver nfp_common_pci_driver = {
+	.driver = {
+		.name = NFP_PCI_DRIVER_NAME,
+	},
+	.probe = nfp_common_pci_probe,
+	.remove = nfp_common_pci_remove,
+};
+
+static void
+nfp_common_init(void)
+{
+	const struct rte_pci_id empty_table[] = {
+		{
+			.vendor_id = 0
+		},
+	};
+
+	if (nfp_common_initialized)
+		return;
+
+	/*
+	 * All the constructor of NFP PMDs run at same priority. So any of the PMD
+	 * including this one can register the PCI table first. If any other
+	 * PMD(s) have registered the PCI ID table, no need to register an empty
+	 * default one.
+	 */
+	if (nfp_pci_id_table == NULL && nfp_pci_id_table_update(empty_table) != 0)
+		return;
+
+	rte_pci_register(&nfp_common_pci_driver);
+	nfp_common_initialized = true;
+}
+
+void
+nfp_class_driver_register(struct nfp_class_driver *driver)
+{
+	nfp_common_init();
+
+	if (driver->id_table != NULL) {
+		if (nfp_pci_id_table_update(driver->id_table) != 0)
+			return;
+	}
+
+	nfp_common_pci_driver.drv_flags |= driver->drv_flags;
+
+	TAILQ_INSERT_TAIL(&nfp_drivers_list, driver, next);
+}
diff --git a/drivers/common/nfp/nfp_common_pci.h b/drivers/common/nfp/nfp_common_pci.h
new file mode 100644
index 0000000000..21465fca68
--- /dev/null
+++ b/drivers/common/nfp/nfp_common_pci.h
@@ -0,0 +1,44 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2023 Corigine, Inc.
+ * All rights reserved.
+ */
+
+#ifndef __NFP_COMMON_PCI_H__
+#define __NFP_COMMON_PCI_H__
+
+#include <bus_pci_driver.h>
+
+/* Initialization function for the driver called during device probing. */
+typedef int (nfp_class_driver_probe_t)(struct rte_pci_device *dev);
+
+/* Uninitialization function for the driver called during hot-unplugging. */
+typedef int (nfp_class_driver_remove_t)(struct rte_pci_device *dev);
+
+enum nfp_class {
+	NFP_CLASS_ETH,
+	NFP_CLASS_INVALID,
+};
+
+/* Describing a nfp common class driver. */
+struct nfp_class_driver {
+	TAILQ_ENTRY(nfp_class_driver) next;
+	enum nfp_class drv_class;            /**< Class of this driver. */
+	const char *name;                    /**< Driver name. */
+	const struct rte_pci_id *id_table;   /**< ID table, NULL terminated. */
+	uint32_t drv_flags;                  /**< Flags RTE_PCI_DRV_*. */
+	nfp_class_driver_probe_t *probe;     /**< Device probe function. */
+	nfp_class_driver_remove_t *remove;   /**< Device remove function. */
+};
+
+/**
+ * Register a nfp device driver.
+ *
+ * @param driver
+ *   A pointer to a nfp_driver structure describing the driver
+ *   to be registered.
+ */
+__rte_internal
+void
+nfp_class_driver_register(struct nfp_class_driver *driver);
+
+#endif /* __NFP_COMMON_PCI_H__ */
diff --git a/drivers/common/nfp/version.map b/drivers/common/nfp/version.map
new file mode 100644
index 0000000000..25e48c39d6
--- /dev/null
+++ b/drivers/common/nfp/version.map
@@ -0,0 +1,7 @@
+INTERNAL {
+	global:
+
+	nfp_class_driver_register;
+
+	local: *;
+};
diff --git a/drivers/meson.build b/drivers/meson.build
index 8c775bbe62..af70ed322c 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -15,6 +15,7 @@ subdirs = [
         'common/mlx5',    # depends on bus.
         'common/qat',     # depends on bus.
         'common/sfc_efx', # depends on bus.
+        'common/nfp',     # depends on bus.
         'mempool',        # depends on common and bus.
         'dma',            # depends on common and bus.
         'net',            # depends on common, bus, mempool